' ****************************************************************************************
'
'   GENERAL DEFINITIONS
'
' ****************************************************************************************
  $regfile = "2313def.dat"                                  'regfile must match the chip
  $crystal = 4000000                                        'crystal must match too
' ****************************************************************************************

  Ddrb = &B00111100                                         ' Use pin 2..7 as outputs
  Ddrd = &B01111111                                         ' Use pin 0,1,4..6 as outputs

  Vmess Alias Portb.1                                       ' D1  PB1 AI1 Voltage input
  Vramp Alias Portb.0                                       ' D0  PB0 AI0 Ramp compare input
  Vswitch Alias Portd.6                                     ' SDA PB6 IC  Switched 0utput for ramp

  Swa Alias Pinb.7                                          ' D7  PB7 SCK Switch flank A
  Swb Alias Pinb.6                                          ' D6  PB6 MIS Switch flank B

  Red Alias Portb.5                                         ' D5  PB5 MOS Red charge control LED
  Green Alias Portb.4                                       ' D4  PB4     Green charge control LED

  Lamp_1d Alias Portb.2                                     ' D2  PB2     Lamp 1 dimmed
  Lamp_1 Alias Portb.3                                      ' D3  PB3 OC1 Lamp 1
  Lamp_2 Alias Portd.4                                      ' IO  PD4 T0  Lamp 2
  Lamp_3 Alias Portd.1                                      ' SO  PD1 TXD Lamp 3
  Lamp_4 Alias Portd.5                                      ' SCL PD5 T1  Lamp 4
  Lamp_5 Alias Portd.0                                      ' SI  PD0 RXD Lamp 5
  Lamp_6 Alias Portd.2                                      ' D8  PD2 IN0 Lamp 6
  Lamp_7 Alias Portd.3                                      ' D9  PD3 IN1 Lamp 7


' ****************************************************************************************

  Dim Lamps As Word                                         ' Number of burning lamps

  Dim H As Bit                                              ' BASCOM Languague restriction patch

' ****************************************************************************************
'
'   PROGRAM BEGIN
'
' ****************************************************************************************

Begin:

Again:
  If Lamps = 0 Then
     Lamps = 1
  End If

  H = Swa Or Swb

  If H = 0 Then
     Shift Lamps , Left
     Waitms 999                                             ' Give time to discharge capacitor
  Else
     If Swb = 1 Then
        Lamps = 127
     End If
     If Swa = 1 Then
        Lamps = 2047
     End If
  End If


' ****************************************************************************************
' Brightness to lamps mixing
' Mixing / adaption of usd HW and program
' ****************************************************************************************

  Lamp_1d = Lamps.1                                         ' D2  PB2     Lamp 1 dimmed
  Lamp_1 = Lamps.2                                          ' D3  PB3 OC1 Lamp 1
  Lamp_2 = Lamps.3                                          ' IO  PD4 T0  Lamp 2
  Lamp_3 = Lamps.4                                          ' SO  PD1 TXD Lamp 3
  Lamp_4 = Lamps.5                                          ' SCL PD5 T1  Lamp 4
  Lamp_5 = Lamps.6                                          ' SI  PD0 RXD Lamp 5
  Lamp_6 = Lamps.7                                          ' D8  PD2 IN0 Lamp 6
  Lamp_7 = Lamps.8                                          ' D9  PD3 IN1 Lamp 7
  Red = Lamps.9                                             ' D5  PB5 MOS Red charge control LED
  Green = Lamps.10                                          ' D4  PB4     Green charge control LED
Goto Again
End


